"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const custom_rule_1 = __importDefault(require("../../rule/custom-rule"));
exports.default = custom_rule_1.default.create({
    name: 'required-attr',
    defaultLevel: 'warning',
    defaultValue: [],
    defaultOptions: null,
    async verify(document, messages) {
        const reports = [];
        await document.walkOn('Element', async (node) => {
            const requiredAttrs = typeof node.rule.value === 'string'
                ? [node.rule.value]
                : node.rule.value;
            requiredAttrs.forEach(attr => {
                if (!node.hasAttribute(attr)) {
                    const message = messages('Required {0} on {1}', `'${attr}'`, `'<${node.nodeName}>'`);
                    reports.push({
                        severity: node.rule.severity,
                        message,
                        line: node.line,
                        col: node.col,
                        raw: node.raw,
                    });
                }
            });
        });
        return reports;
    },
});
